---
title: Commonly-used macros
slug: MDN/Structures/Macros/Commonly-used_macros
tags:
  - CSS
  - Macros
  - Reference
  - Structures
---
<p>{{MDNSidebar}}</p>

<p><span class="seoSummary">This page lists many of the general-purpose macros created for use on MDN. For how-to information on using these macros, see <a href="/en-US/docs/MDN/Contribute/Structures/Macros">Using macros</a> and <a href="/en-US/docs/MDN/Contribute/Editor/Links#Using_link_macros">Using link macros</a>.</span> See <a href="/en-US/docs/MDN/Contribute/Structures/Macros/Other">Other macros</a> for information on macros that are infrequently used, are used only in special contexts, or are deprecated. There is also a <a href="/en-US/dashboards/macros">complete list of all macros on MDN</a>. </p>

<p>See also the <a href="/en-US/docs/MDN/Contribute/Guidelines/CSS_style_guide">CSS style guide</a> for styles available for your use.</p>

<h2 id="Linking">Linking</h2>

<h3 id="Creating_a_single_hyperlink">Creating a single hyperlink</h3>

<p id="To_another_MDN_page_or_its_section_(anch_SectionOnPage_manch_Link_LinkItem_LinkItemDL)">In general, you don't need to use macros for creating arbitrary links. Use the <strong>Link</strong> button in the Editor interface to create links. </p>

<ul>
 <li>The {{TemplateLink("Glossary")}} macro creates a link to a specified term's entry in the MDN <a href="/en-US/docs/Glossary">glossary</a>. This macro accepts one required and two optional parameters:

  <p>Examples:</p>

  <ol>
   <li>The term's name (such as "HTML").</li>
   <li>The text to display in the article instead of the term name (this should be used rarely).{{Optional_Inline}}</li>
   <li>If this parameter is specified and is non-zero, the custom styling normally applied to glossary links is not applied.{{Optional_Inline}}</li>
  </ol>

  <ul>
   <li><code>\{{Glossary("HTML")}}</code> yields {{Glossary("HTML")}}</li>
   <li><code>\{{Glossary("CSS", "Cascading Style Sheets")}}</code> yields {{Glossary("CSS", "Cascading Style Sheets")}}</li>
   <li><code>\{{Glossary("HTML", "", 1)}}</code> yields {{Glossary("HTML", "", 1)}}</li>
  </ul>
 </li>
 <li>{{TemplateLink("anch")}} - creates link to in-page section:
  <ul>
   <li><code>\{{anch("Linking to pages in references")}}</code>;</li>
   <li>
    <p>Demo: {{anch("Linking to pages in references")}}</p>
   </li>
  </ul>
 </li>
</ul>

<h3 id="Linking_to_pages_in_references">Linking to pages in references</h3>

<p>There are various macros for linking to pages in specific reference areas of MDN.</p>

<ul>
 <li>{{TemplateLink("cssxref")}} links to a page in the <a href="/en-US/docs/Web/CSS/Reference">CSS Reference</a>.<br>
  Example: <code>\{{CSSxRef("cursor")}}</code>, results in: {{CSSxRef("cursor")}}.</li>
 <li>{{TemplateLink("domxref")}} links to pages in the DOM reference; if you include parentheses at the end, the template knows to display the link to look like a function name. For example, <code>\{{DOMxRef("document.getElementsByName()")}}</code> results in {{DOMxRef("document.getElementsByName()")}} while <code>\{{DOMxRef("Node")}}</code> results in {{DOMxRef("Node")}}.</li>
 <li>{{TemplateLink("event")}} links to pages in the DOM Event reference, for example: <code>\{{Event("change")}}</code> results in {{Event("change")}}.</li>
 <li>{{TemplateLink("HTMLElement")}} links to an HTML element in the HTML Reference.</li>
 <li>{{TemplateLink("htmlattrxref")}} links to an HTML attribute, either a global attribute description if you only specify the attribute name or an attribute associated with a specific element if you specify an attribute name and an element name. For example, <code>\{{HTMLAttrxRef("lang")}} </code>will create this link: {{HTMLAttrxRef("lang")}}. <code>\{{HTMLAttrxRef("type","input")}}</code> will create this link: {{htmlattrxref("type","input")}}.</li>
 <li>{{TemplateLink("jsxref")}} links to a page in the <a href="/en-US/docs/Web/JavaScript/Reference">JavaScript Reference</a>.</li>
 <li>{{TemplateLink("SVGAttr")}} links to a specific SVG attribute. For example, <code>\{{SVGAttr("d")}}</code> creates this link: {{SVGAttr("d")}}.</li>
 <li>{{TemplateLink("SVGElement")}} links to an SVG element in the SVG Reference.</li>
 <li>{{TemplateLink("HTTPHeader")}} links to an <a href="/en-US/docs/Web/HTTP/Headers">HTTP header</a>.</li>
 <li>{{TemplateLink("HTTPMethod")}} links to an <a href="/en-US/docs/Web/HTTP/Methods">HTTP request method</a>.</li>
 <li>{{TemplateLink("HTTPStatus")}} links to an <a href="/en-US/docs/Web/HTTP/Status">HTTP response status code</a>.</li>
</ul>

<h3 id="Linking_to_bugs">Linking to bugs</h3>

<ul>
 <li>Bugs
  <ul>
   <li>{{TemplateLink("bug")}} allows you to link to a bug on bugzilla.mozilla.org easily using this syntax: <code>\{{Bug(123456)}}</code>. This gives you: {{Bug(123456)}}.</li>
   <li>{{TemplateLink("WebkitBug")}} inserts a link to a bug in the WebKit bug database. For example, <code>\{{WebkitBug(31277)}}</code> inserts {{WebkitBug(31277)}}.</li>
  </ul>
 </li>
</ul>

<h3 id="Navigation_aids_for_multi-page_guides">Navigation aids for multi-page guides</h3>

<p>{{TemplateLink("Previous")}}, {{TemplateLink("Next")}}, and {{TemplateLink("PreviousNext")}} provide navigation controls for articles which are part of sequences. For the single-way templates, the only parameter needed is the wiki location of the previous or next article in the sequence. For {{TemplateLink("PreviousNext")}}, the two parameters needed are the wiki locations of the appropriate articles. The first parameter is for the previous article and the second is for the next article.</p>

<h2 id="Code_samples">Code samples</h2>

<h3 id="Live_samples">Live samples</h3>

<ul>
 <li>{{TemplateLink("EmbedLiveSample")}} lets you embed the output of a code sample on a page, as described in <a href="/en-US/docs/MDN/Contribute/Structures/Live_samples">Live samples</a>.</li>
 <li>{{TemplateLink("LiveSampleLink")}} creates a link to a page containing the output of a code sample on a page, as described in <a href="/en-US/docs/MDN/Contribute/Structures/Live_samples">Live samples</a>.</li>
</ul>

<h2 id="Sidebar_generation">Sidebar generation</h2>

<p>There are templates for almost every large collection of pages. They typically link back to the main page of the reference/guide/tutorial (this is often needed because our breadcrumbs sometimes can't do this) and put the article in the appropriate category.</p>

<ul>
 <li>{{TemplateLink("CSSRef")}} generates the sidebar for CSS reference pages.</li>
 <li>{{TemplateLink("HTMLRef")}} generates the sidebar for HTML reference pages.</li>
 <li>{{TemplateLink("APIRef")}} generates the sidebar for Web API reference pages.</li>
</ul>

<h2 id="General-purpose_formatting">General-purpose formatting</h2>

<h3 id="Inline_indicators_for_API_documentation">Inline indicators for API documentation</h3>

<p>{{TemplateLink("optional_inline")}} and {{TemplateLink("ReadOnlyInline")}} are used in API documentation, usually when describing the list of properties of an object or parameters of a function.</p>

<p>Usage: <code>\{{Optional_Inline}}</code> or <code>\{{ReadOnlyInline}}</code>. Example:</p>

<dl>
 <dt><code>isCustomObject</code>{{ReadOnlyInline}}</dt>
 <dd>Indicates, if <code>true</code>, that the object is a custom one.</dd>
 <dt><code>parameterX</code>{{Optional_Inline}}</dt>
 <dd>Blah blah blah...</dd>
</dl>

<h2 id="Status_and_compatibility_indicators">Status and compatibility indicators</h2>

<h3 id="Inline_indicators_with_no_additional_parameters">Inline indicators with no additional parameters</h3>

<h4 id="Non-standard">Non-standard</h4>

<p>{{TemplateLink("non-standard_inline")}} inserts an in-line mark indicating the API has not been standardized and is not on a standards track.</p>

<h5 id="Syntax">Syntax</h5>

<p><code>\{{Non-standard_Inline}}</code></p>

<h5 id="Examples">Examples</h5>

<ul>
 <li>Icon: {{Non-standard_Inline}}</li>
</ul>

<h4 id="Experimental">Experimental</h4>

<p>{{TemplateLink("experimental_inline")}} inserts an in-line mark indicating the API is not widely implemented and may change in the future.</p>

<h5 id="Syntax_2">Syntax</h5>

<p><code>\{{Experimental_Inline}}</code></p>

<h5 id="Examples_2">Examples</h5>

<ul>
 <li>Icon: {{Experimental_Inline}}</li>
</ul>

<h3 id="Inline_indicators_that_support_specifying_the_technology">Inline indicators that support specifying the technology</h3>

<p>In these macros the parameter (when specified) should be one of the strings "html", "js", "css", or "gecko", followed by the version number.</p>

<h4 id="Deprecated">Deprecated</h4>

<p>{{TemplateLink("deprecated_inline")}} inserts an in-line deprecated mark to discourage the use of an API that is officially deprecated. <strong>Note:</strong> "Deprecated" means that the item should no longer be used, but still functions. If you mean that it no longer works at all, use the term "obsolete."</p>

<p>Don't use the parameter in any browser-agnostic area (HTML, APIs, JS, CSS, …).</p>

<h5 id="Syntax_3">Syntax</h5>

<p><code>\{{Deprecated_Inline}}</code> or<code> \{{Deprecated_Inline("gecko5")}}</code></p>

<h5 id="Examples_3">Examples</h5>

<ul>
 <li>Icon: {{Deprecated_Inline}}</li>
 <li>Badge:{{Deprecated_Inline("gecko5")}}</li>
</ul>

<h4 id="Obsolete">Obsolete</h4>

<p>{{TemplateLink("obsolete_inline")}} inserts an in-line obsolete mark to prevent the use of, for example, a function, method or property which is officially obsolete.</p>

<p>Don't use the parameter in any browser-agnostic area (HTML, APIs, JS, CSS, …).</p>

<h5 id="Syntax_4">Syntax</h5>

<p><code>\{{Obsolete_Inline}}</code> or <code>\{{Obsolete_Inline("js1.8.5")}}</code></p>

<h5 id="Examples_4">Examples</h5>

<ul>
 <li>Icon: {{Obsolete_Inline}}</li>
 <li>Badge:{{Obsolete_Inline("js1.8.5")}}</li>
</ul>

<h3 id="Template_badges">Template badges</h3>

<p>These macros are mostly used on the <a href="/en-US/docs/Web/API">WebAPI</a> page. See {{anch("Creating new badges")}} for information on creating a new badge.</p>

<h3 id="Page_or_section_header_indicators">Page or section header indicators</h3>

<p>These templates have the same semantics as their inline counterparts described above. The templates should be placed directly underneath the main page title (or breadcrumb navigation if available) in the reference page. They can also be used to mark up a section on a page.</p>

<ul>
 <li>{{TemplateLink("non-standard_header")}}: <code>\{{Non-standard_Header}}</code> {{Non-standard_Header}}</li>
 <li>{{TemplateLink("SeeCompatTable")}} should be used on pages that document <a href="/en-US/docs/MDN/Contribute/Guidelines/Conventions_definitions#Experimental">experimental features</a>. Example: <code>\{{SeeCompatTable}}</code> {{SeeCompatTable}}</li>
 <li>{{TemplateLink("deprecated_header")}}: <code>\{{Deprecated_Header}}</code> {{Deprecated_Header}}</li>
 <li>{{TemplateLink("deprecated_header")}} with parameter: <code>\{{Deprecated_Header("gecko5")}}</code> {{Deprecated_Header("gecko5")}} Don't use the parameter in any browser-agnostic area (HTML, APIs, JS, CSS, …).</li>
 <li>{{TemplateLink("obsolete_header")}}: <code>\{{Obsolete_Header}}</code> {{Obsolete_Header}}</li>
 <li>{{TemplateLink("obsolete_header")}} with parameter: <code>\{{Obsolete_Header("gecko30")}}</code> {{Obsolete_Header("gecko30")}} Don't use the parameter in any browser-agnostic area (HTML, APIs, JS, CSS, …).</li>
 <li>{{TemplateLink("secureContext_header")}}: <code>\{{SecureContext_Header}}</code> {{SecureContext_Header}}</li>
</ul>

<h3 id="Indicating_that_a_feature_is_available_in_web_workers">Indicating that a feature is available in web workers</h3>

<p>The {{TemplateLink("AvailableInWorkers")}} macro inserts a localised note box indicating that a feature is available in a <a href="/en-US/docs/Web/API/Web_Workers_API">Web worker</a> context.</p>

<p>{{AvailableInWorkers}}</p>
